/**
 * Copyright © 2016-2019 Anasoft Technology AG
 */
package de.technology.ourpuppet.tests.speech;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.TargetDataLine;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.Line;

/**
 * @author Anasoft Technology AG
 */
public class MicStreamingClient {

	/**
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
    final AudioFormat format = new AudioFormat(16000.0f, 16, 1, true, false);
    final DataLine.Info info = new DataLine.Info(TargetDataLine.class, format);
    final TargetDataLine microphone = (TargetDataLine) AudioSystem.getLine(info);
    //final Mixer.Info[] mixerInfos = AudioSystem.getMixerInfo();
    //final Mixer mixer = AudioSystem.getMixer(mixerInfos[0]);
    //final Line.Info[] firstMixerLineInfos = mixer.getTargetLineInfo();
    //final TargetDataLine microphone = (TargetDataLine) AudioSystem.getLine(
      //firstMixerLineInfos[0]);

    microphone.open(format);

    //for(int i = 0; i < mixerInfos.length; i++) {
      //Mixer mixer = AudioSystem.getMixer(mixerInfos[i]);

      //Line.Info[] lineInfos = mixer.getTargetLineInfo();

      //System.out.println(mixerInfos[i].toString());

      //for(int m = 0; m < lineInfos.length; m++) {
        //System.out.println("\t" + lineInfos[m].toString());
      //}
      //System.out.println("");
    //}

		final byte[] data = new byte[microphone.getBufferSize() / 5];
		microphone.start();

    System.out.println("Will use: " + microphone.toString());
		while (!Thread.currentThread().isInterrupted()) {
			try (Socket socket = new Socket("172.16.64.20", 54321);
					OutputStream outputStream = socket.getOutputStream();
					OutputStream fileOut = new FileOutputStream("audio.pcm")) {
        System.out.println("connected");
				int read = 0;
				while ((read = microphone.read(data, 0, data.length)) != -1) {
					outputStream.write(data, 0, read);
					outputStream.flush();

					fileOut.write(data, 0, read);
					fileOut.flush();
				}
			} catch (IOException ex) {
				System.out.println("Will try reconnecting in 2000ms");
				try {
					Thread.sleep(2000);
				} catch (InterruptedException ex1) {
					break;
				}
			}
		}

		microphone.close();
	}
}
